# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.HealthCare.V1.Model.AnalyzeEntitiesRequest do
  @moduledoc """
  The request to analyze healthcare entities in a document.

  ## Attributes

  *   `alternativeOutputFormat` (*type:* `String.t`, *default:* `nil`) - Optional. Alternative output format to be generated based on the results of analysis.
  *   `documentContent` (*type:* `String.t`, *default:* `nil`) - document_content is a document to be annotated.
  *   `licensedVocabularies` (*type:* `list(String.t)`, *default:* `nil`) - A list of licensed vocabularies to use in the request, in addition to the default unlicensed vocabularies.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :alternativeOutputFormat => String.t() | nil,
          :documentContent => String.t() | nil,
          :licensedVocabularies => list(String.t()) | nil
        }

  field(:alternativeOutputFormat)
  field(:documentContent)
  field(:licensedVocabularies, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.HealthCare.V1.Model.AnalyzeEntitiesRequest do
  def decode(value, options) do
    GoogleApi.HealthCare.V1.Model.AnalyzeEntitiesRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.HealthCare.V1.Model.AnalyzeEntitiesRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
