# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.HealthCare.V1.Model.EntityMentionRelationship do
  @moduledoc """
  Defines directed relationship from one entity mention to another.

  ## Attributes

  *   `confidence` (*type:* `float()`, *default:* `nil`) - The model's confidence in this annotation. A number between 0 and 1.
  *   `objectId` (*type:* `String.t`, *default:* `nil`) - object_id is the id of the object entity mention.
  *   `subjectId` (*type:* `String.t`, *default:* `nil`) - subject_id is the id of the subject entity mention.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :confidence => float() | nil,
          :objectId => String.t() | nil,
          :subjectId => String.t() | nil
        }

  field(:confidence)
  field(:objectId)
  field(:subjectId)
end

defimpl Poison.Decoder, for: GoogleApi.HealthCare.V1.Model.EntityMentionRelationship do
  def decode(value, options) do
    GoogleApi.HealthCare.V1.Model.EntityMentionRelationship.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.HealthCare.V1.Model.EntityMentionRelationship do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
