# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.HealthCare.V1.Model.Feature do
  @moduledoc """
  A feature of an entity mention.

  ## Attributes

  *   `confidence` (*type:* `float()`, *default:* `nil`) - The model's confidence in this feature annotation. A number between 0 and 1.
  *   `value` (*type:* `String.t`, *default:* `nil`) - The value of this feature annotation. Its range depends on the type of the feature.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :confidence => float() | nil,
          :value => String.t() | nil
        }

  field(:confidence)
  field(:value)
end

defimpl Poison.Decoder, for: GoogleApi.HealthCare.V1.Model.Feature do
  def decode(value, options) do
    GoogleApi.HealthCare.V1.Model.Feature.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.HealthCare.V1.Model.Feature do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
