# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.HealthCare.V1.Model.FhirStoreMetric do
  @moduledoc """
  Count of resources and total storage size by type for a given FHIR store.

  ## Attributes

  *   `count` (*type:* `String.t`, *default:* `nil`) - The total count of FHIR resources in the store of this resource type.
  *   `resourceType` (*type:* `String.t`, *default:* `nil`) - The FHIR resource type this metric applies to.
  *   `structuredStorageSizeBytes` (*type:* `String.t`, *default:* `nil`) - The total amount of structured storage used by FHIR resources of this resource type in the store.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :count => String.t() | nil,
          :resourceType => String.t() | nil,
          :structuredStorageSizeBytes => String.t() | nil
        }

  field(:count)
  field(:resourceType)
  field(:structuredStorageSizeBytes)
end

defimpl Poison.Decoder, for: GoogleApi.HealthCare.V1.Model.FhirStoreMetric do
  def decode(value, options) do
    GoogleApi.HealthCare.V1.Model.FhirStoreMetric.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.HealthCare.V1.Model.FhirStoreMetric do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
