# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.HealthCare.V1beta1.Model.ConfigureSearchRequest do
  @moduledoc """
  Request to configure the search parameters for the specified FHIR store.

  ## Attributes

  *   `canonicalUrls` (*type:* `list(String.t)`, *default:* `nil`) - The canonical URLs of the search parameters that are intended to be used for the FHIR store. See https://www.hl7.org/fhir/references.html#canonical for explanation on FHIR canonical urls
  *   `validateOnly` (*type:* `boolean()`, *default:* `nil`) - If `validate_only` is set to true, the method will compile all the search parameters without actually setting the search config for the store and triggering the reindex.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :canonicalUrls => list(String.t()) | nil,
          :validateOnly => boolean() | nil
        }

  field(:canonicalUrls, type: :list)
  field(:validateOnly)
end

defimpl Poison.Decoder, for: GoogleApi.HealthCare.V1beta1.Model.ConfigureSearchRequest do
  def decode(value, options) do
    GoogleApi.HealthCare.V1beta1.Model.ConfigureSearchRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.HealthCare.V1beta1.Model.ConfigureSearchRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
