# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.HealthCare.V1beta1.Model.DeidentifyOperationMetadata do
  @moduledoc """
  Details about the work the de-identify operation performed.

  ## Attributes

  *   `fhirOutput` (*type:* `GoogleApi.HealthCare.V1beta1.Model.FhirOutput.t`, *default:* `nil`) - Details about the FHIR store to write the output to.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :fhirOutput => GoogleApi.HealthCare.V1beta1.Model.FhirOutput.t() | nil
        }

  field(:fhirOutput, as: GoogleApi.HealthCare.V1beta1.Model.FhirOutput)
end

defimpl Poison.Decoder, for: GoogleApi.HealthCare.V1beta1.Model.DeidentifyOperationMetadata do
  def decode(value, options) do
    GoogleApi.HealthCare.V1beta1.Model.DeidentifyOperationMetadata.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.HealthCare.V1beta1.Model.DeidentifyOperationMetadata do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
