# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.HealthCare.V1beta1.Model.DicomStoreMetrics do
  @moduledoc """
  DicomStoreMetrics contains metrics describing a DICOM store.

  ## Attributes

  *   `blobStorageSizeBytes` (*type:* `String.t`, *default:* `nil`) - Total blob storage bytes for all instances in the store.
  *   `instanceCount` (*type:* `String.t`, *default:* `nil`) - Number of instances in the store.
  *   `name` (*type:* `String.t`, *default:* `nil`) - Resource name of the DICOM store, of the form `projects/{project_id}/locations/{location_id}/datasets/{dataset_id}/dicomStores/{dicom_store_id}`.
  *   `seriesCount` (*type:* `String.t`, *default:* `nil`) - Number of series in the store.
  *   `structuredStorageSizeBytes` (*type:* `String.t`, *default:* `nil`) - Total structured storage bytes for all instances in the store.
  *   `studyCount` (*type:* `String.t`, *default:* `nil`) - Number of studies in the store.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :blobStorageSizeBytes => String.t() | nil,
          :instanceCount => String.t() | nil,
          :name => String.t() | nil,
          :seriesCount => String.t() | nil,
          :structuredStorageSizeBytes => String.t() | nil,
          :studyCount => String.t() | nil
        }

  field(:blobStorageSizeBytes)
  field(:instanceCount)
  field(:name)
  field(:seriesCount)
  field(:structuredStorageSizeBytes)
  field(:studyCount)
end

defimpl Poison.Decoder, for: GoogleApi.HealthCare.V1beta1.Model.DicomStoreMetrics do
  def decode(value, options) do
    GoogleApi.HealthCare.V1beta1.Model.DicomStoreMetrics.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.HealthCare.V1beta1.Model.DicomStoreMetrics do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
