# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.HealthCare.V1beta1.Model.DicomTagConfig do
  @moduledoc """
  Specifies the parameters needed for the de-identification of DICOM stores.

  ## Attributes

  *   `actions` (*type:* `list(GoogleApi.HealthCare.V1beta1.Model.Action.t)`, *default:* `nil`) - Specifies custom tag selections and `Actions` to apply to them. Overrides `options` and `profile`. Conflicting `Actions` are applied in the order given.
  *   `options` (*type:* `GoogleApi.HealthCare.V1beta1.Model.Options.t`, *default:* `nil`) - Specifies additional options to apply, overriding the base `profile`.
  *   `profileType` (*type:* `String.t`, *default:* `nil`) - Base profile type for handling DICOM tags.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :actions => list(GoogleApi.HealthCare.V1beta1.Model.Action.t()) | nil,
          :options => GoogleApi.HealthCare.V1beta1.Model.Options.t() | nil,
          :profileType => String.t() | nil
        }

  field(:actions, as: GoogleApi.HealthCare.V1beta1.Model.Action, type: :list)
  field(:options, as: GoogleApi.HealthCare.V1beta1.Model.Options)
  field(:profileType)
end

defimpl Poison.Decoder, for: GoogleApi.HealthCare.V1beta1.Model.DicomTagConfig do
  def decode(value, options) do
    GoogleApi.HealthCare.V1beta1.Model.DicomTagConfig.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.HealthCare.V1beta1.Model.DicomTagConfig do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
