# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.HealthCare.V1beta1.Model.ExplainDataAccessResponse do
  @moduledoc """
  List of consent scopes that are applicable to the explained access on a given resource.

  ## Attributes

  *   `consentScopes` (*type:* `list(GoogleApi.HealthCare.V1beta1.Model.ExplainDataAccessConsentScope.t)`, *default:* `nil`) - List of applicable consent scopes. Sorted in order of actor such that scopes belonging to the same actor will be adjacent to each other in the list.
  *   `warning` (*type:* `String.t`, *default:* `nil`) - Warnings associated with this response. It inform user with exceeded scope limit errors.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :consentScopes =>
            list(GoogleApi.HealthCare.V1beta1.Model.ExplainDataAccessConsentScope.t()) | nil,
          :warning => String.t() | nil
        }

  field(:consentScopes,
    as: GoogleApi.HealthCare.V1beta1.Model.ExplainDataAccessConsentScope,
    type: :list
  )

  field(:warning)
end

defimpl Poison.Decoder, for: GoogleApi.HealthCare.V1beta1.Model.ExplainDataAccessResponse do
  def decode(value, options) do
    GoogleApi.HealthCare.V1beta1.Model.ExplainDataAccessResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.HealthCare.V1beta1.Model.ExplainDataAccessResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
